# from xaal.lib import tools

import asyncio
import pdb
import logging
from pprint import pprint


from zwave_js_server.client import Client as ZwaveClient
from aiohttp.client import ClientSession

from xaal.lib import AsyncEngine
from xaal.schemas import devices


PACKAGE_NAME = 'xaal.zwavejs'

logger = logging.getLogger(__name__)
# Disable zwave-js-server logs
logging.getLogger("zwave_js_server").setLevel(logging.WARNING)


URL = "ws://10.77.3.143:3000"


class GW:
    def __init__(self, engine: AsyncEngine):
        self.engine = engine
        logger.debug("ZwaveJS gateway initialized")
        engine.on_start(self.start)
        gw = devices.gateway()
        gw.new_attribute("gw", self)
        engine.add_device(gw)

    async def start(self):
        sess = ClientSession()
        self.client = ZwaveClient(URL, sess)
        await self.client.connect()
        self.ready = asyncio.Event()
        self.engine.new_task(self.client.listen(self.ready))
        # await self.client.listen(ready)
        logger.warning("Done")
        await self.run()

    async def run(self):
        await self.ready.wait()
        assert self.client.driver
        # logger.warning(self.client.controller.nodes)
        logger.warning("ZwaveJS ready")
        nodes = self.client.driver.controller.nodes
        for node in nodes.values():
            if node.ready:
                logger.warning(f"{node.node_id} {node.device_config.manufacturer}/{node.device_config.label} ")
                for k in node.values:
                    value = node.values.get(k)
                    print(f"{k} {value.property_name} => {value.value}")
            # pprint(node.data)


def setup(eng):
    GW(eng)
    return True
